/** BEGIN COPYRIGHT BLOCK
 * Copyright 2001 Sun Microsystems, Inc.
 * Portions copyright 1999, 2001-2003 Netscape Communications Corporation.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*

      nsctrs.h

 */

#ifndef _NSCTRS_H_
#define _NSCTRS_H_

#pragma pack (4)

#define NS_NUM_PERF_OBJECT_TYPES 1
#define NUM_CONN_RATE_OFFSET	    		sizeof(DWORD)
#define NUM_THROUGHPUT_OFFSET	    		NUM_CONN_RATE_OFFSET + sizeof(DWORD)
#define NUM_TOTAL_BYTES_WRITTEN_OFFSET		NUM_THROUGHPUT_OFFSET + sizeof(DWORD)
#define NUM_TOTAL_BYTES_READ_OFFSET		NUM_TOTAL_BYTES_WRITTEN_OFFSET + sizeof(DWORD)
#define NUM_OP_RATE_OFFSET			NUM_TOTAL_BYTES_READ_OFFSET + sizeof(DWORD)
#define NUM_TOTAL_ERRORS_OFFSET			NUM_OP_RATE_OFFSET + sizeof(DWORD)
#define NUM_SEARCH_RATE_OFFSET			NUM_TOTAL_ERRORS_OFFSET + sizeof(DWORD)
#define ADD_RATE_OFFSET				NUM_SEARCH_RATE_OFFSET + sizeof(DWORD)
#define DELETE_RATE_OFFSET			ADD_RATE_OFFSET + sizeof(DWORD)
#define MODIFY_RATE_OFFSET			DELETE_RATE_OFFSET + sizeof(DWORD)
#define COMPARE_RATE_OFFSET			MODIFY_RATE_OFFSET + sizeof(DWORD)
#define MODDN_RATE_OFFSET			COMPARE_RATE_OFFSET + sizeof(DWORD)
#define CONNECTIONS_OFFSET			MODDN_RATE_OFFSET + sizeof(DWORD)
#define BIND_RATE_OFFSET			CONNECTIONS_OFFSET + sizeof(DWORD)
#define ENTRIES_RETURNED_OFFSET		BIND_RATE_OFFSET + sizeof(DWORD)
#define ENTRIES_RETURNED_RATE_OFFSET		ENTRIES_RETURNED_OFFSET + sizeof(DWORD)
#define REFERRALS_RETURNED_OFFSET		ENTRIES_RETURNED_RATE_OFFSET + sizeof(DWORD)
#define REFERRALS_RETURNED_RATE_OFFSET		REFERRALS_RETURNED_OFFSET + sizeof(DWORD)
#define BYTES_READ_RATE_OFFSET		REFERRALS_RETURNED_RATE_OFFSET + sizeof(DWORD)
#define BYTES_WRITTEN_RATE_OFFSET	BYTES_READ_RATE_OFFSET + sizeof(DWORD)
#define SIZE_OF_NS_PERFORMANCE_DATA     	BYTES_WRITTEN_RATE_OFFSET + sizeof(DWORD)

typedef struct _NS_DATA_DEFINITION {
    	PERF_OBJECT_TYPE	NS_ObjectType;
    	PERF_COUNTER_DEFINITION	connection_rate;
    	PERF_COUNTER_DEFINITION	throughput;
	PERF_COUNTER_DEFINITION total_bytes_written;
	PERF_COUNTER_DEFINITION total_bytes_read;
	PERF_COUNTER_DEFINITION	operation_rate;
	PERF_COUNTER_DEFINITION total_errors;
	PERF_COUNTER_DEFINITION search_rate;
	PERF_COUNTER_DEFINITION add_rate;
	PERF_COUNTER_DEFINITION delete_rate;
	PERF_COUNTER_DEFINITION modify_rate;
	PERF_COUNTER_DEFINITION compare_rate;
	PERF_COUNTER_DEFINITION moddn_rate;
	PERF_COUNTER_DEFINITION connections;
	PERF_COUNTER_DEFINITION bind_rate;
	PERF_COUNTER_DEFINITION entries_returned;
	PERF_COUNTER_DEFINITION entries_returned_rate;
	PERF_COUNTER_DEFINITION referrals_returned;
	PERF_COUNTER_DEFINITION referrals_returned_rate;
	PERF_COUNTER_DEFINITION bytes_read_rate;
	PERF_COUNTER_DEFINITION bytes_written_rate;
} NS_DATA_DEFINITION;

#pragma pack ()

#endif /* _NSCTRS_H_ */
  
